#!/usr/local/bin/perl -w
# GenBank format に書いてあるアミノ酸配列を抜き出してくるスクリプト．
# 主にミトコンドリアゲノム用．

# 操作   aaSeqRetFromGBK.pl GenBankForm11spp.gbk


use strict;
use warnings;

my $inFile = "$ARGV[0]";
my @inFileArray = ( );

my $spname = "";
my $gene = "";
my $seq = "";
my $accNum = "";

my %seqHash = ( );
my %allHash = ( );

my $stone = 0;
my $seqStone = 0;

open(IN,"$inFile");
@inFileArray = <IN>;
close IN;

foreach my $line (@inFileArray) {

  if($line =~ /^LOCUS       ([a-zA-Z0-9\_\.]+)\s+.*?$/){
    $accNum = $1;
  }

  if($line =~ /^  ORGANISM  (.*?)$/) {     # 種名をとってくる．
    $spname = $1;
    $spname =~ s/\s+/_/g;
#    print "$spname";
  }

   if($stone == 1){         # CDS 内部に入って行を処理．
     if ($line =~ /                     \/gene=\"(.*?)\"/) {
       $gene = $1;
#       print "$spname_$gene\n";
     }

     if($seqStone == 1) {
       if($line =~ /^                     [a-zA-Z]+$/){
         $line =~ s/\s//g;
         $seq .= $line;
       }
       if($line =~ /^                     [a-zA-Z]+\"$/){      #sequence の終わりの行なので，ここでプリントアウトして，変数を初期化する
         $line =~ s/\s//g;
         $line =~ s/\"//g;
         $seq .= $line;
         
         my $pname = ">".$spname." \($accNum\)_"."".$gene;
         print "$pname\n$seq\n";
         $seqHash{$pname} = $seq;
         $allHash{$pname} = $seq;
         $seq = "";
         $seqStone = 0;
         $stone = 0;
         next;
       }
     }
     
     if ($line =~ /                     \/translation=\"(.*?)$/){   # この行に来たらシーケンスをとり始める．
       $seq = $1; 
       $seqStone = 1;
     }
     
   }

   if($line =~ /^     CDS/){             # CDS に入ったら，stone =1
      $stone = 1;
   }
   
   if($line =~ /^\/\//){
     open(OUT,">010\_$spname\.fas");
       foreach (keys %seqHash) {
         print OUT "$_\n$seqHash{$_}\n";
     }
     close OUT;
     
     
     
     $spname = "";
     $seq = "";
     $accNum = "";
     %seqHash = ( );
     
   }
   
}


# 遺伝子ごとのファイルも作成する．
my @geneName = ('ND1','ND2','ND3','ND4','ND4L','ND5','ND6','COX1','COX2','COX3','CYTB','ATP6','ATP8');
foreach my $eachGene (@geneName) {
  open(GENE,">020\_$eachGene\.fas");
  foreach my $keyName (keys %allHash) {
    if($keyName =~ /$eachGene/) {
      my $newKeyName = $keyName;
      $newKeyName =~ s/\_\w+$//g;
      print GENE "$newKeyName\n$allHash{$keyName}\n";
    }
  }
  close GENE;
}
exit;